#include "main.h"
#include "dlg_main.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BOOL CControlPanelDlg::OnTooltip_NeedText( UINT id, NMHDR* pNMHDR, LRESULT* pResult )
{
	TOOLTIPTEXT*	pTooltip = (TOOLTIPTEXT*)pNMHDR;
	BOOL			Status = FALSE;

//Is it tooltip of a dlg item?
	if ( ( pTooltip->uFlags & TTF_IDISHWND ) != 0 )
	{
	//Yes -> get dlgItem ID.
		int			nID = ::GetDlgCtrlID( (HWND)pTooltip->hdr.idFrom );

	//Get selected card.
		ioctl_cardInfo_s*	pCard = Cards_Tree_GetSelected();
		if ( pCard != NULL )
		{
		//Is it one of the useful dlg items?
			bool		useful_disabled = false;
			bool		useful_monitoring = false;

			switch ( pCard->m_Type )
			{
			case ioctl_cardInfo_s::CARD_TYPE_424:
			{
				switch ( nID )
				{
				//case IDC_IN_GAIN_1: break;
				case IDC_IN_GAIN_2: useful_disabled = true; break;
				case IDC_IN_GAIN_3: useful_disabled = true; break;
				case IDC_IN_GAIN_4: useful_disabled = true; break;
				case IDC_IN_GAIN_5: useful_disabled = true; break;
				case IDC_IN_GAIN_6: useful_disabled = true; break;
				case IDC_IN_GAIN_7: useful_disabled = true; break;
				case IDC_IN_GAIN_8: useful_disabled = true; break;
				case IDC_MON_1: useful_monitoring = true; break;
				case IDC_MON_2: useful_monitoring = true; break;
				case IDC_MON_3: useful_monitoring = true; break;
				case IDC_MON_4: useful_monitoring = true; break;
				case IDC_MON_5: useful_disabled = true; break;
				case IDC_MON_6: useful_disabled = true; break;
				case IDC_MON_7: useful_disabled = true; break;
				case IDC_MON_8: useful_disabled = true; break;
				case IDC_MUTE_1: break;
				case IDC_MUTE_2: break;
				case IDC_MUTE_3: break;
				case IDC_MUTE_4: break;
				case IDC_MUTE_5: useful_disabled = true; break;
				case IDC_MUTE_6: useful_disabled = true; break;
				case IDC_MUTE_7: useful_disabled = true; break;
				case IDC_MUTE_8: useful_disabled = true; break;
				case IDC_OUT_GAIN_1: useful_disabled = true; break;
				case IDC_OUT_GAIN_2: useful_disabled = true; break;
				case IDC_OUT_GAIN_3: useful_disabled = true; break;
				case IDC_OUT_GAIN_4: useful_disabled = true; break;
				case IDC_OUT_GAIN_5: useful_disabled = true; break;
				case IDC_OUT_GAIN_6: useful_disabled = true; break;
				case IDC_OUT_GAIN_7: useful_disabled = true; break;
				case IDC_OUT_GAIN_8: useful_disabled = true; break;
				}
				break;
			}
			case ioctl_cardInfo_s::CARD_TYPE_496:
			{
				switch ( nID )
				{
				//case IDC_IN_GAIN_1: break;
				case IDC_IN_GAIN_2: useful_disabled = true; break;
				case IDC_IN_GAIN_3: useful_disabled = true; break;
				case IDC_IN_GAIN_4: useful_disabled = true; break;
				case IDC_IN_GAIN_5: useful_disabled = true; break;
				case IDC_IN_GAIN_6: useful_disabled = true; break;
				case IDC_IN_GAIN_7: useful_disabled = true; break;
				case IDC_IN_GAIN_8: useful_disabled = true; break;
				case IDC_MON_1: useful_monitoring = true; break;
				case IDC_MON_2: useful_monitoring = true; break;
				case IDC_MON_3: useful_monitoring = true; break;
				case IDC_MON_4: useful_monitoring = true; break;
				case IDC_MON_5: useful_disabled = true; break;
				case IDC_MON_6: useful_disabled = true; break;
				case IDC_MON_7: useful_disabled = true; break;
				case IDC_MON_8: useful_disabled = true; break;
				case IDC_MUTE_1: break;
				case IDC_MUTE_2: break;
				case IDC_MUTE_3: break;
				case IDC_MUTE_4: break;
				case IDC_MUTE_5: useful_disabled = true; break;
				case IDC_MUTE_6: useful_disabled = true; break;
				case IDC_MUTE_7: useful_disabled = true; break;
				case IDC_MUTE_8: useful_disabled = true; break;
				case IDC_OUT_GAIN_1: break;
				case IDC_OUT_GAIN_2: useful_disabled = true; break;
				case IDC_OUT_GAIN_3: useful_disabled = true; break;
				case IDC_OUT_GAIN_4: useful_disabled = true; break;
				case IDC_OUT_GAIN_5: useful_disabled = true; break;
				case IDC_OUT_GAIN_6: useful_disabled = true; break;
				case IDC_OUT_GAIN_7: useful_disabled = true; break;
				case IDC_OUT_GAIN_8: useful_disabled = true; break;
				}
				break;
			}
			case ioctl_cardInfo_s::CARD_TYPE_824:
			{
				switch ( nID )
				{
				case IDC_MON_1: useful_monitoring = true; break;
				case IDC_MON_2: useful_monitoring = true; break;
				case IDC_MON_3: useful_monitoring = true; break;
				case IDC_MON_4: useful_monitoring = true; break;
				case IDC_MON_5: useful_monitoring = true; break;
				case IDC_MON_6: useful_monitoring = true; break;
				case IDC_MON_7: useful_monitoring = true; break;
				case IDC_MON_8: useful_monitoring = true; break;
				}
				break;
			}
			}

		//Display tooltip... if it's disabled... it means that ASIO channel is opened.
			if ( useful_monitoring == true )
			{
				if ( FALSE == ::IsWindowEnabled( (HWND)pTooltip->hdr.idFrom ) )
				{
					pTooltip->lpszText = "ASIO channel: use ASIO application's direct monitoring";

				//Message processed.
					Status = TRUE;
				}
			}
			else if ( useful_disabled == true )
			{
				if ( FALSE == ::IsWindowEnabled( (HWND)pTooltip->hdr.idFrom ) )
				{
					pTooltip->lpszText = "Property not supported on current card.";

				//Message processed.
					Status = TRUE;
				}
			}
			else
			{
				switch ( nID )
				{
				case IDC_IN_GAIN_1:
				case IDC_IN_GAIN_2:
				case IDC_IN_GAIN_3:
				case IDC_IN_GAIN_4:
				case IDC_IN_GAIN_5:
				case IDC_IN_GAIN_6:
				case IDC_IN_GAIN_7:
				case IDC_IN_GAIN_8:
				{
					pTooltip->lpszText = "-10dBV = higher input volume / +4dBu = lower input volume";

				//Message processed.
					Status = TRUE;
					break;
				}
				case IDC_OUT_GAIN_1:
				case IDC_OUT_GAIN_2:
				case IDC_OUT_GAIN_3:
				case IDC_OUT_GAIN_4:
				case IDC_OUT_GAIN_5:
				case IDC_OUT_GAIN_6:
				case IDC_OUT_GAIN_7:
				case IDC_OUT_GAIN_8:
				{
					pTooltip->lpszText = "-10dBV = lower output volume / +4dBu = higher ouput volume";

				//Message processed.
					Status = TRUE;
					break;
				}
				}
			}
		}
		else
		{
			if ( FALSE == ::IsWindowEnabled( (HWND)pTooltip->hdr.idFrom ) )
			{
				pTooltip->lpszText = "Property not supported on current card.";

			//Message processed.
				Status = TRUE;
			}
		}
	}

//Exit..
	*pResult = 0;
	return Status;
}

